VERSION 5.00
Begin VB.Form frmHaupt 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Kapitel 7: Experimentierlabor fr OLE-Drag&Drop"
   ClientHeight    =   5340
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5205
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5340
   ScaleWidth      =   5205
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.ComboBox cboOLEDragMode 
      Height          =   315
      Left            =   120
      TabIndex        =   12
      Text            =   "Combo1"
      Top             =   2400
      Width           =   2055
   End
   Begin VB.ComboBox cboOLEDropMode 
      Height          =   315
      Left            =   2640
      TabIndex        =   10
      Text            =   "Combo1"
      Top             =   1080
      Width           =   2415
   End
   Begin VB.Frame Frame1 
      Caption         =   "Zusatzeinstellungen"
      Height          =   1095
      Left            =   2640
      TabIndex        =   6
      Top             =   1560
      Width           =   2415
      Begin VB.CheckBox chkGiveFeedBackAnzeigen 
         Caption         =   "OLEGiveFeedBack"
         Height          =   255
         Left            =   120
         TabIndex        =   8
         Top             =   360
         Width           =   1815
      End
      Begin VB.CheckBox chkSetDataAllowed 
         Caption         =   "Mit SetData arbeiten"
         Height          =   255
         Left            =   120
         TabIndex        =   7
         Top             =   720
         Width           =   1935
      End
   End
   Begin VB.TextBox txtZiel 
      Height          =   495
      Left            =   2640
      OLEDropMode     =   1  'Manuell
      TabIndex        =   5
      Text            =   "Text1"
      Top             =   240
      Width           =   2415
   End
   Begin VB.ListBox lstEreignisse 
      Height          =   2205
      Left            =   120
      TabIndex        =   3
      Top             =   3120
      Width           =   4935
   End
   Begin VB.ListBox lstQuelle 
      Height          =   1815
      Left            =   120
      OLEDragMode     =   1  'Automatisch
      TabIndex        =   0
      Top             =   240
      Width           =   2055
   End
   Begin VB.Label Label5 
      Caption         =   "OLEDragMode-Eigenschaft:"
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   2160
      Width           =   2055
   End
   Begin VB.Label Label4 
      Caption         =   "OLEDropMode-Eigenschaft"
      Height          =   255
      Left            =   2640
      TabIndex        =   9
      Top             =   840
      Width           =   2295
   End
   Begin VB.Image imgMaus 
      Height          =   480
      Left            =   4080
      Picture         =   "frmOLEDragDrop.frx":0000
      Top             =   2640
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Label Label3 
      Caption         =   "OLE-Drag&Drop-Ereignisse"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   2880
      Width           =   2055
   End
   Begin VB.Label Label2 
      Caption         =   "&Ziel:"
      Height          =   255
      Left            =   2640
      TabIndex        =   2
      Top             =   0
      Width           =   2175
   End
   Begin VB.Label Label1 
      Caption         =   "&Quelle:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   0
      Width           =   1695
   End
End
Attribute VB_Name = "frmHaupt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *******************************
' Beispielprogramm aus Kapitel 7 - OLEDragDrop-Beispiel
' Das Visual Basic 6.0 Kompendium
' Peter Monadjemi, Markt&Technik 1998
' *******************************
Option Explicit

Private Sub cboDragMode_Click()
    lstQuelle.OLEDragMode = cboOLEDragMode.ListIndex
End Sub

Private Sub cboOLEDropMode_Click()
    txtZiel.OLEDropMode = cboOLEDropMode.ListIndex
End Sub

Private Sub Form_Load()
    lstQuelle.AddItem "Gelsenkirchen"
    lstQuelle.AddItem "Wanne Eickel"
    lstQuelle.AddItem "Bottrop"
    lstQuelle.AddItem "Herne"
    lstQuelle.AddItem "Wuppertal"
    lstQuelle.AddItem "Bochum"
    cboOLEDragMode.AddItem "Manuell"
    cboOLEDragMode.AddItem "Automatisch"
    cboOLEDropMode.AddItem "Kein"
    cboOLEDropMode.AddItem "Manuell"
    cboOLEDropMode.AddItem "Automatisch"
    cboOLEDragMode.ListIndex = 0
    cboOLEDropMode.ListIndex = 1
End Sub

Private Sub lstEreignisse_DblClick()
    lstEreignisse.Clear
End Sub

Private Sub lstQuelle_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Button = vbRightButton Then  ' Wurde die rechte Maustaste gedrckt
       lstQuelle.OLEDrag            ' Dann OLE-Drag&Drop starten
    End If
End Sub

Private Sub lstQuelle_OLECompleteDrag(Effect As Long)
    lstEreignisse.AddItem "CompleteDrag bei Quelle mit Effect = " & Effect
    If Effect = vbDropEffectMove Then               ' Verschiebeoperation?
       lstQuelle.RemoveItem lstQuelle.ListIndex     ' Dann Element aus Liste entfernen
    End If
    Screen.MousePointer = vbDefault
End Sub

Private Sub lstQuelle_OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
    If chkGiveFeedBackAnzeigen.Value = 1 Then
       lstEreignisse.AddItem "GiveFeedback bei Quelle mit Effect = " & Effect
    End If
    If Effect = vbDropEffectMove Then
       DefaultCursors = False
       Screen.MousePointer = vbCustom
       Screen.MouseIcon = imgMaus.Picture
    End If
End Sub

Private Sub lstQuelle_OLESetData(Data As DataObject, DataFormat As Integer)
    lstEreignisse.AddItem "SetData bei Quelle"
    Data.SetData lstQuelle.List(lstQuelle.ListIndex), vbCFText
End Sub

Private Sub lstQuelle_OLEStartDrag(Data As DataObject, AllowedEffects As Long)
    lstEreignisse.AddItem "StartDrag bei Quelle"
    If chkSetDataAllowed.Value = 1 Then
        Data.SetData , vbCFText
    Else
       Data.SetData lstQuelle.List(lstQuelle.ListIndex), vbCFText
    End If
    AllowedEffects = vbDropEffectMove Or vbDropEffectCopy ' Sowohl Kopieren (1) als auch Verschieben (2) erlaubt
End Sub

Private Sub txtZiel_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    lstEreignisse.AddItem "DragDrop bei Quelle mit Effect = " & Effect
    If Shift = vbCtrlMask Then                  ' Wurde die Strg-Taste gedrckt?
       Effect = vbDropEffectMove                ' Ja, dann Verschieben an OLECompleteDrag melden
    Else
       Effect = vbDropEffectCopy                ' Ansonsten nur Kopieren melden
    End If
    If Data.GetFormat(vbCFText) Then            ' Liegt Text in der Ablage vor?
       txtZiel.SelText = Data.GetData(vbCFText) ' Ja, dann Text holen
    End If
End Sub

Private Sub txtZiel_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    If State = vbEnter Then
       lstEreignisse.AddItem "DragOver bei Quelle mit Effect = " & Effect
    End If
    If Shift = vbCtrlMask Then   ' Wurde die Strg-Taste gedrckt?
       Effect = vbDropEffectMove ' Ja, dann Verschieben an OLEGiveFeedback melden
    Else
       Effect = vbDropEffectCopy ' Ansonsten nur Kopieren
    End If
End Sub
