VERSION 5.00
Begin VB.Form frmDevisenrechner 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "bung: Universeller Devisenrechner"
   ClientHeight    =   3645
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3645
   ScaleWidth      =   6000
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.ComboBox cboErgebnis 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   390
      Left            =   0
      TabIndex        =   6
      Text            =   "Combo1"
      Top             =   3120
      Width           =   5775
   End
   Begin VB.CommandButton cmdUmrechnen 
      Caption         =   "&Umrechnen"
      Height          =   975
      Left            =   2040
      Style           =   1  'Grafisch
      TabIndex        =   5
      Top             =   1560
      Width           =   1935
   End
   Begin VB.TextBox txtDMBetrag 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   15.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   480
      Width           =   1935
   End
   Begin VB.ComboBox cboWhrungen 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   390
      Left            =   3120
      Style           =   2  'Dropdown-Liste
      TabIndex        =   1
      Top             =   480
      Width           =   2175
   End
   Begin VB.Label lbKurs 
      Alignment       =   2  'Zentriert
      BackColor       =   &H00000000&
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0000FF00&
      Height          =   375
      Left            =   3120
      TabIndex        =   8
      Top             =   1080
      Width           =   1695
   End
   Begin VB.Label Label4 
      Caption         =   "Der aktuelle Kurs ist: "
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   1080
      Width           =   2415
   End
   Begin VB.Line Line2 
      X1              =   3120
      X2              =   5280
      Y1              =   960
      Y2              =   960
   End
   Begin VB.Label Label3 
      Caption         =   "Ergebnis:"
      Height          =   255
      Left            =   0
      TabIndex        =   4
      Top             =   2880
      Width           =   1935
   End
   Begin VB.Line Line1 
      X1              =   0
      X2              =   5760
      Y1              =   2760
      Y2              =   2760
   End
   Begin VB.Label Label2 
      Caption         =   "DM-Betrag:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   240
      Width           =   1935
   End
   Begin VB.Label Label1 
      Caption         =   "&Whrung:"
      Height          =   255
      Left            =   3120
      TabIndex        =   0
      Top             =   240
      Width           =   2055
   End
End
Attribute VB_Name = "frmDevisenrechner"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *************************************
' Kapitel 9 - Ein universeller Devisenrechner zum ben der VBA-Befehle
'
' Peter Monadjemi - Das Visual Basic 6.0 Kompendium
' *************************************

Option Explicit
' Diese API-Funktion liest den Inhalt einer Ini-Datei ein
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" _
(ByVal lpApplicationName As String, ByVal lpKeyName As Any, _
 ByVal lpDefault As String, ByVal lpReturnedString As String, _
 ByVal nSize As Long, ByVal lpFileName As String) As Long
' In diesen dynamischen Feldvariablen wird der Inhalt
' der Ini-Datei zwischengespeichert
Private Wechselkurse() As Currency
Private Whrungsnamen() As String
Private picFlagge() As IPictureDisp
' Wichtig: Diese Verzeichnisspfade mssen unbedingt angepat werden!
' Sonst gibt es eine Fehlermeldung
Const DevisenIniDateiName = "F:\WIN95\Profiles\Chef\Desktop\VB6-Kompendium\Beispielprogramme\Kapitel9\devisen.ini"
Const FlaggenPfad = "C:\Programme\Microsoft Visual Studio\Common\Graphics\Icons\Flags\"

' *************************************
' Wird eine Whrung aus der Liste gewhlt,
' soll die passende Flagge angezeigt werden
' *************************************

Private Sub cboWhrungen_Click()
    cmdUmrechnen.Picture = picFlagge(cboWhrungen.ListIndex)
    lbKurs.Caption = Wechselkurse(cboWhrungen.ListIndex)
' Whrungssymbol auch im Symbolfeld des Formulars anzeigen (kleiner Gag)
    Me.Icon = cmdUmrechnen.Picture
End Sub

' *************************************
' Beim Umrechnen kommt es darauf an, den Inhalt des Textfeldes txtDMBetrag
' mit dem Wechselkurs aus der Feldvariablen Wechselkurse umzurechnen
' Der Index fr den Feldzugriff entspricht dem Wert der ListIndex-Eigenschaft
' in dem Kombinationsfeld mit den Whrungsnamen
' *************************************

Private Sub cmdUmrechnen_Click()
    Dim tmpErgebnis As String
    If IsNumeric(txtDMBetrag.Text) = True Then
       tmpErgebnis = txtDMBetrag.Text / Wechselkurse(cboWhrungen.ListIndex)
       cboErgebnis.AddItem "Fr " & txtDMBetrag.Text & _
        " DM erhalten Sie " & Format(tmpErgebnis, "0.00 ") _
        & Whrungsnamen(cboWhrungen.ListIndex)
       cboErgebnis.ListIndex = cboErgebnis.NewIndex
    End If
End Sub

' *************************************
' Hier beginnt die Programmausfhrung
' *************************************

Private Sub Form_Load()
    txtDMBetrag.MaxLength = 10
    txtDMBetrag.Text = "100"
' Den Inhalt von Devisen.ini einlesen
    WhrungenEinlesen
' Den ersten Eintrag im Kombinationslistenfeld im Textfeld anzeigen
    cboWhrungen.ListIndex = 0
    cboErgebnis.Text = ""
End Sub

' *************************************
' Wie immer sollen nur numerische Zeichen
' erlaubt sein.
' *************************************

Private Sub txtDMBetrag_KeyPress(KeyAscii As Integer)
    Select Case Chr(KeyAscii)
     Case "0" To "9"
     Case Chr(vbKeyBack)
     Case ",", "."
      If InStr(txtDMBetrag.Text, ",") <> 0 Then
         KeyAscii = 0
      Else
         KeyAscii = 44
      End If
     Case Else
       KeyAscii = 0
    End Select
End Sub

' *************************************
' In dieser Prozedur wird der Inhalt der Datei Devisen.ini mit der API-Funktion
' GetPrivateProfileString eingelesen.
' *************************************

Sub WhrungenEinlesen()
    Dim RetVal As Long
    Dim AlleWhrungsNamen As String, Kurs As String, Devisenbezeichnung As String
    Dim WhrungsName As String, FlaggenName As String
    Dim n As Long, BlankPosition As Long
' Hier werden die dynamischen Feldvariablen das erste Mal dimensioniert
    ReDim Wechselkurse(0 To 1)
    ReDim picFlagge(0 To 1)
    ReDim Whrungsnamen(0 To 1)
' Wichtig ist, da die Stringvariablen, die an GetPrivateProfileString bergeben werden,
' mit ausreichend Leerzeichen gefllt sind
    AlleWhrungsNamen = Space(1024)    ' Mit Leerzeichen fllen
' Die Namen aller Whrungen (der Namen in eckigen Klammern) in AlleWhrungsNamen einlesen
    RetVal = GetPrivateProfileString(vbNullString, _
      vbNullString, "", AlleWhrungsNamen, Len(AlleWhrungsNamen), _
       DevisenIniDateiName)
' Jetzt den Inhalt von AlleWhrungsNamen der Reihe nach durchgehen
' Alle Namen sind durch ein vbNullChar-Zeichen getrennt
    Do
       FlaggenName = Space(128)
       Devisenbezeichnung = Space(128)
       Kurs = Space(32)
' Wo steht das erste vbNullChar-Zeichen?
       BlankPosition = InStr(AlleWhrungsNamen, vbNullChar)
' Wenn keine mehr da, dann Schleife verlassen
       If BlankPosition = 1 Then Exit Do
' Den ersten Namen extrahieren...
       WhrungsName = Left(AlleWhrungsNamen, BlankPosition - 1)
' ... und aus dem Gesamtstring entfernen
       AlleWhrungsNamen = Right(AlleWhrungsNamen, Len(AlleWhrungsNamen) - BlankPosition)
' Whrungsname zur Liste hinzufgen
       cboWhrungen.AddItem WhrungsName
' ber den Whrungsnamen den Flaggenpfad lesen
       RetVal = GetPrivateProfileString(WhrungsName, _
        "Flagge", "", FlaggenName, Len(FlaggenName), _
       DevisenIniDateiName)
       FlaggenName = Left(FlaggenName, InStr(FlaggenName, vbNullChar) - 1)
' ber den Whrungsnamen den Umrechnungskurs lesen
       RetVal = GetPrivateProfileString(WhrungsName, _
        "Kurs", "", Kurs, Len(Kurs), DevisenIniDateiName)
       Kurs = Left(Kurs, InStr(Kurs, vbNullChar) - 1)
' ber den Whrungsnamen die Devisenbezeichnung lesen
       RetVal = GetPrivateProfileString(WhrungsName, _
        "Name", "", Devisenbezeichnung, Len(Devisenbezeichnung), DevisenIniDateiName)
       Devisenbezeichnung = Left(Devisenbezeichnung, InStr(Devisenbezeichnung, vbNullChar) - 1)

' Mu das dynamische Feld vergrert werden?
       If UBound(Wechselkurse) = n Then
' Wenn ja, dann 5 Felder dazu (nicht mehr, damit kein Speicherplatz verschenkt wird)
          ReDim Preserve Wechselkurse(n + 5)
          ReDim Preserve picFlagge(n + 5)
          ReDim Preserve Whrungsnamen(n + 5)
       End If
' Feldvariablen mit Werten belegen
       Wechselkurse(n) = CCur(Kurs)
       Whrungsnamen(n) = Devisenbezeichnung
       If FlaggenName <> "" Then
          Set picFlagge(n) = LoadPicture(FlaggenPfad & FlaggenName)
       End If
       n = n + 1
    Loop
End Sub

' *************************************
' Ende des Programms
' *************************************

       

