VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsSearchEngine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
' *******************************
' Kapitel 6: FileFinder
' Klasse clsSearchEngine
' Das Visual Basic 5 Kompendium
' Peter Monadjemi, Markt&Technik 1997
' *******************************
Option Explicit

Private mStopSearch As Boolean
Private Rekursionen As Integer
Private Zhler As Integer

Public StartVerzeichnis As String
Public SuchDateiName As String
Public Unterverzeichnisse As Boolean

Public Event DateiGefunden(Datei As clsDateiObjekt)

Public objDirBox As DirListBox
Public objFileBox As FileListBox
Public objAktuellesDirLabel As Label
Public objRekursionenLabel As Label
' Public objErgebnisListe As ListBox

Public GefundeneDatei As clsDateiObjekt
Public GefundeneDateiListe As New Collection

Property Let StopSearch(tmpWert As Boolean)
    mStopSearch = tmpWert
End Property

Property Get StopSearch() As Boolean
    StopSearch = mStopSearch
End Property

Sub Search()
    objDirBox.Path = StartVerzeichnis
    objFileBox.Pattern = SuchDateiName
    objFileBox.Path = StartVerzeichnis
    Rekursionen = 0
    Call Rekursive
    mStopSearch = False
End Sub

Private Sub Rekursive()
    Dim n As Integer, m As Integer, OldPath As String
    Dim Pfadname As String
    ' Zunchst alle Dateien aus dem aktuellen Verzeichnis bertragen
    If mStopSearch = True Then
       Exit Sub
    End If
    objAktuellesDirLabel.Caption = objFileBox.Path
    objAktuellesDirLabel.Refresh
    For m = 0 To objFileBox.ListCount - 1
        Set GefundeneDatei = New clsDateiObjekt
        Pfadname = objFileBox.Path & IIf(Right(objFileBox.Path, 1) = "\", "", "\") _
        & objFileBox.List(m)
        GefundeneDatei.Pfadname = Pfadname
        GefundeneDatei.Filename = objFileBox.List(m)
        GefundeneDatei.FileSize = FileLen(Pfadname)
        GefundeneDatei.FileDate = FileDateTime(Pfadname)
        GefundeneDatei.ReadOnly = Sgn(GetAttr(Pfadname) And 1)
        GefundeneDatei.Hidden = Sgn(GetAttr(Pfadname) And 2)
        GefundeneDatei.System = Sgn(GetAttr(Pfadname) And 4)
        GefundeneDateiListe.Add Item:=GefundeneDatei, Key:="Datei" & Format(Zhler, "0000")
        RaiseEvent DateiGefunden(GefundeneDatei)
        Set GefundeneDatei = Nothing
        Zhler = Zhler + 1
    Next m
    ' Sollen auch Unterverzeichnisse durchsucht werden?
    If Unterverzeichnisse = False Then Exit Sub
    ' Alle Unterverzeichnisse des aktuellen Verzeichnisses durchgehen
    For n = 0 To objDirBox.ListCount - 1
    ' Auf das erste Unterverzeichnis umschalten
        OldPath = objDirBox.Path
        objDirBox.Path = objDirBox.List(n)
    ' Alle Dateien des Unterverzeichnis in Dateilistenfeld bertragen
        objFileBox.Path = objDirBox.Path
    ' Alle Unterverzeichnisse des aktuellen Verzeichnisses durchgehen
        Rekursionen = Rekursionen + 1
        objRekursionenLabel.Caption = Rekursionen
        objRekursionenLabel.Refresh
    ' Andere Ereignisse zulassen
        DoEvents
    ' Prozedur ruft sich selber auf um Unterverzeichnisse zu finden
        Call Rekursive
        If mStopSearch = True Then Exit For
    ' Verzeichnis der nchst hheren Ebene wiederherstellen
        objDirBox.Path = OldPath
    Next n
End Sub

Private Function StripFileName(Dateiname As String)
    Dim Pos As Integer, LastPos As Integer
    Do
        LastPos = Pos
        Pos = InStr(LastPos + 1, Dateiname, "\")
    Loop Until Pos = 0
    StripFileName = Right(Dateiname, Len(Dateiname) - LastPos)
End Function

