VERSION 5.00
Begin VB.Form frmHaupt 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Kapitel 6 - bung 6.2: Ereignisse in Klassen mit Cancel-Option"
   ClientHeight    =   3705
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6810
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3705
   ScaleWidth      =   6810
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdStop 
      Height          =   735
      Left            =   4440
      Picture         =   "frmEventSortierenII.frx":0000
      Style           =   1  'Grafisch
      TabIndex        =   6
      Top             =   2640
      Width           =   615
   End
   Begin VB.ListBox lstNachher 
      Height          =   1425
      Left            =   5280
      TabIndex        =   4
      Top             =   1320
      Width           =   1215
   End
   Begin VB.ListBox lstVorher 
      Height          =   1425
      Left            =   240
      TabIndex        =   3
      Top             =   1440
      Width           =   1095
   End
   Begin VB.PictureBox picFortschritt 
      Height          =   495
      Left            =   218
      ScaleHeight     =   435
      ScaleWidth      =   6315
      TabIndex        =   1
      Top             =   720
      Width           =   6375
   End
   Begin VB.CommandButton cmdSortieren 
      Caption         =   "&Sortieren"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   735
      Left            =   2536
      TabIndex        =   0
      Top             =   2640
      Width           =   1695
   End
   Begin VB.Label lblAnzahlVertauschungen 
      Alignment       =   2  'Zentriert
      BorderStyle     =   1  'Fest Einfach
      Height          =   255
      Left            =   1898
      TabIndex        =   5
      Top             =   1440
      Width           =   2775
   End
   Begin VB.Label lblFortschritt 
      Alignment       =   2  'Zentriert
      BorderStyle     =   1  'Fest Einfach
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   2634
      TabIndex        =   2
      Top             =   120
      Width           =   975
   End
End
Attribute VB_Name = "frmHaupt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Const AnzahlElemente = 1000
Private StopModus As Boolean

Private Sortierfeld() As Integer
' Hier wird die Ereignissenke definiert - eine normale Instanz der Klasse clsSortieren
Private WithEvents SortierMich As clsSortieren
Attribute SortierMich.VB_VarHelpID = -1

Private Sub cmdSortieren_Click()
    Dim n As Integer
    Me.MousePointer = vbArrowHourglass
' Die Sortieren-Methode wird aufgerufen
    lblAnzahlVertauschungen.Caption = SortierMich.Sortieren(Sortierfeld) & " Vertauschungen"
    Me.MousePointer = vbDefault
    For n = 1 To AnzahlElemente
        lstNachher.AddItem Sortierfeld(n)
    Next n
End Sub

Private Sub cmdStop_Click()
    StopModus = True
End Sub

Private Sub Form_Load()
    Dim n As Integer, z As Integer
' Hier wird die Ereignissenke aktiviert - ab jetzt knnen Ereignisse eintreffen
    ReDim Sortierfeld(0 To AnzahlElemente)
    Set SortierMich = New clsSortieren
    picFortschritt.Scale (0, 0)-(100, 10)
    picFortschritt.FillStyle = vbSolid
    picFortschritt.FillColor = RGB(255, 0, 0)
    For n = 1 To AnzahlElemente
        z = Int(Rnd * 1000)
        Sortierfeld(n) = z
        lstVorher.AddItem Sortierfeld(n)
    Next n
End Sub

Private Sub SortierMich_Fortschritt(Schleifenzhler As Integer, Cancel As Boolean)
    Static LastX As Integer
    Static Fortschritt As Integer
    If StopModus = True Then
       StopModus = False
       Cancel = True
       Exit Sub
    End If
    Fortschritt = (Schleifenzhler / AnzahlElemente) * 100
    lblFortschritt.Caption = Fortschritt & "%"
    If Fortschritt < LastX + AnzahlElemente \ 200 Then Exit Sub
    picFortschritt.Line (LastX, 0)-(Fortschritt, 10), , B
    DoEvents
    LastX = Fortschritt
End Sub
