VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form frmHaupt 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Beispiel:  Schiffe versenken mit dem MsFlexGrid"
   ClientHeight    =   6030
   ClientLeft      =   1125
   ClientTop       =   1785
   ClientWidth     =   8880
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'ZReihenfolge
   ScaleHeight     =   6030
   ScaleWidth      =   8880
   ShowInTaskbar   =   0   'False
   Begin MSFlexGridLib.MSFlexGrid grdSpielfeld 
      Height          =   5295
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   8655
      _ExtentX        =   15266
      _ExtentY        =   9340
      _Version        =   393216
   End
   Begin VB.Image imgSpielstein 
      Height          =   480
      Index           =   6
      Left            =   2880
      Picture         =   "frmSchiffeVersenken.frx":0000
      Top             =   5520
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Image imgSpielstein 
      Height          =   480
      Index           =   5
      Left            =   2280
      Picture         =   "frmSchiffeVersenken.frx":0442
      Top             =   5520
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Image imgSpielstein 
      Height          =   480
      Index           =   4
      Left            =   1800
      Picture         =   "frmSchiffeVersenken.frx":0884
      Top             =   5520
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Image imgSpielstein 
      Height          =   480
      Index           =   3
      Left            =   1320
      Picture         =   "frmSchiffeVersenken.frx":0CC6
      Top             =   5520
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Image imgSpielstein 
      Height          =   480
      Index           =   2
      Left            =   840
      Picture         =   "frmSchiffeVersenken.frx":1108
      Top             =   5520
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Image imgSpielstein 
      Height          =   480
      Index           =   1
      Left            =   360
      Picture         =   "frmSchiffeVersenken.frx":154A
      Top             =   5520
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Menu mnuNeuesSpielfeld 
      Caption         =   "&Neues Spielfeld  "
   End
End
Attribute VB_Name = "frmHaupt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *******************************
' Beispielprogramm fr das MsFlexGrid-Steuerelement
'
' Das Visual Basic 6.0 Kompendium
' Peter Monadjemi, Markt&Technik 1998
' *******************************
Option Explicit
Private Spielfeld() As Boolean
Private SpielfeldAufbau As Variant

Sub SpielfeldBelegen()
    Dim Spalte As Integer, Zeile As Integer, KonvoyGre As Integer
    Dim SchiffNr As Integer, s As Integer
    Dim VertikalAusrichtung As Boolean, KonvoyOk As Boolean
    ReDim Spielfeld(10, 10)
' Diese Anweisung legt die Anzahl und die Gre der Konvoys fest
    SpielfeldAufbau = Array(6, 5, 4, 3, 3, 2, 2, 2, 1, 1, 1, 1)
' Zufallszahlengenerator initialisieren
    Randomize Timer
' Alle Konvoys zusammenauen
    For SchiffNr = 0 To UBound(SpielfeldAufbau)
' Gre des Konvoys bestimmen
    KonvoyGre = SpielfeldAufbau(SchiffNr)
' Startfeld finden, das nicht belegt ist und Platz fr Konvoy bietet
     Do
' Am Anfang darf der Konvoy gesetzt werden
      KonvoyOk = True
' Koordinaten fr Startfeld ermitteln
      Spalte = Int(Rnd * 10) + 1
      Zeile = Int(Rnd * 10) + 1
' Ist das Feld schon belegt?
      If Spielfeld(Spalte, Zeile) = True Then
         KonvoyOk = False
      Else
' Nein, dann prfen, ob Konvoy Platz hat
         VertikalAusrichtung = Rnd > 0.5
         If VertikalAusrichtung Then
' Ist genug Platz fr den Konvoy?
          KonvoyOk = (Zeile + KonvoyGre) <= 10
' Ist das Nachbarfeld am Ende des Konvoys belegt?
          If Zeile + KonvoyGre < 10 Then
             If Spielfeld(Zeile + KonvoyGre + 1, Spalte) = True Then
                 KonvoyOk = False
             End If
          End If
' Sind alle Bedingungen fr das Setzen des Konvoys erfllt?
          If KonvoyOk Then
' Ja, dann prfen ob alle Felder leer sind
           For s = 1 To KonvoyGre
            If Spielfeld(Zeile + s, Spalte) = True Then
               KonvoyOk = False
               Exit For
            End If
           Next s
          End If
         Else
' Konvoy soll in die horizontale gehen
          KonvoyOk = (Spalte + KonvoyGre) <= 10
' Ist das Nachbarfeld am Ende des Konvoys belegt?
          If Spalte + KonvoyGre < 10 Then
             If Spielfeld(Zeile, Spalte + KonvoyGre + 1) = True Then
                 KonvoyOk = False
             End If
          End If
' Sind alle Bedingungen fr das Setzen des Konvoys erfllt?
          If KonvoyOk Then
           For s = 1 To KonvoyGre
            If Spielfeld(Zeile, Spalte + s) = True Then
               KonvoyOk = False
               Exit For
            End If
           Next s
          End If
         End If
       End If
      Loop While KonvoyOk = False
    
' Alles klar, Konvoy hat genug Platz - Schiffe setzen
     For s = 0 To KonvoyGre - 1
' Konvoy wird in vertikaler Richtung aufgebaut
      If VertikalAusrichtung Then
         Zeile = Zeile + 1
      Else
         Spalte = Spalte + 1
      End If
      Spielfeld(Zeile, Spalte) = True
      grdSpielfeld.Row = Zeile
      grdSpielfeld.Col = Spalte
' Das fr den Konvoytyp typische Bild auswhlen
      Set grdSpielfeld.CellPicture = imgSpielstein(KonvoyGre).Picture
     Next
    Next SchiffNr
End Sub
Private Sub Form_Load()
    Dim n As Integer, m As Integer
    Dim Spalte As Integer, Zeile As Integer, AnzahlSchiffe As Integer
' Als erstes das Spielfeld aufbauen
    grdSpielfeld.Rows = 11
    grdSpielfeld.Cols = 11
    grdSpielfeld.Row = 0
    grdSpielfeld.ColWidth(0) = 400
    For n = 1 To 10
        grdSpielfeld.Col = n
        grdSpielfeld.Text = Chr(n + 64)
    Next n
    grdSpielfeld.Col = 0
    For n = 1 To 10
        grdSpielfeld.Row = n
        grdSpielfeld.Text = n
    Next n
    For n = 1 To grdSpielfeld.Rows - 1
        grdSpielfeld.ColWidth(n) = 800
        grdSpielfeld.ColAlignment(n) = vbCenter
        grdSpielfeld.RowHeight(n) = 800
    Next n
    grdSpielfeld.Width = grdSpielfeld.ColWidth(1) * (grdSpielfeld.Cols)
    grdSpielfeld.Height = grdSpielfeld.RowHeight(1) * (grdSpielfeld.Rows)
    Me.Width = grdSpielfeld.Width * 1.1
    Me.Height = grdSpielfeld.Height * 1.1
    SpielfeldBelegen
    For Zeile = 1 To 10
     For Spalte = 1 To 10
      If Spielfeld(Zeile, Spalte) = True Then AnzahlSchiffe = AnzahlSchiffe + 1
     Next Spalte
    Next Zeile
    Me.Caption = Me.Caption & " - Anzahl der Schiffe: " & AnzahlSchiffe
End Sub

Private Sub grdSpielfeld_Click()
    Dim Treffer As Variant
    Dim PluralWort1 As String, PluralWort2 As String
    Dim n As Integer, m As Integer
    Treffer = 0 ' Initialisierung notwendig, da Variant
    If grdSpielfeld.Col <> grdSpielfeld.ColSel _
     Or grdSpielfeld.Row <> grdSpielfeld.RowSel Then
       For n = grdSpielfeld.Row To grdSpielfeld.RowSel
        For m = grdSpielfeld.Col To grdSpielfeld.ColSel
           If Spielfeld(n, m) = True Then
              Treffer = Treffer + 1
           End If
        Next m
       Next n
       PluralWort1 = IIf(Treffer = 1, "befindet", "befinden")
       PluralWort2 = IIf(Treffer = 1, " Schiff!", " Schiffe!")
       MsgBox "In dem Bereich " & PluralWort1 & " sich " & Treffer & PluralWort2, vbExclamation, "Statusbericht"
       Exit Sub
    End If
    If Spielfeld(grdSpielfeld.Row, grdSpielfeld.Col) = True Then
       Treffer = "ein"
    Else
       Treffer = "kein"
    End If
    MsgBox "Auf " & Chr(grdSpielfeld.Col + 64) & grdSpielfeld.Row & " ist " & Treffer & " Schiff!", vbExclamation, "Erfolgsmeldung"

End Sub

Private Sub mnuNeuesSpielfeld_Click()
    Dim Zeile As Integer, Spalte As Integer
    For Zeile = 1 To 10
     grdSpielfeld.Row = Zeile
     For Spalte = 1 To 10
        grdSpielfeld.Col = Spalte
        Set grdSpielfeld.CellPicture = LoadPicture()
     Next Spalte
    Next Zeile
    SpielfeldBelegen
End Sub


