Attribute VB_Name = "basMenuiSelect"
Option Explicit

Private Declare Function SetWindowLong Lib "user32" Alias _
 "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, _
 ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias _
 "CallWindowProcA" (ByVal wndrpcPrev As Long, ByVal hwnd As _
 Long, ByVal uMsg As Long, ByVal wParam As Long, lParam As _
 Any) As Long
Private Declare Function GetMenu Lib "user32" (ByVal hwnd As _
 Long) As Long
Private Declare Function GetMenuString Lib "user32" Alias _
 "GetMenuStringA" (ByVal hMenu As Long, ByVal wIDItem As _
 Long, ByVal lpString As String, ByVal nMaxCount As Long, _
 ByVal wFlag As Long) As Long

Const GWL_WNDPROC = -4
Const WM_COMMAND = &H111
Const WM_MENUSELECT = &H11F
Const MF_BYCOMMAND = &H0&

Private stdWinProc As Long

Sub StartSubClass(hwnd As Long)
    stdWinProc = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf FensterProz)
End Sub

Function FensterProz(ByVal hwnd As Long, ByVal uMsg As Long, _
         ByVal wParam As Long, ByVal lParam As Long) As Long
         Dim hMenu As Long, RetVal As Long
         Dim MenuName As String
         MenuName = Space(64)
         Select Case uMsg
            Case WM_COMMAND
              ' Debug.Print Hex(wParam)
            Case WM_MENUSELECT
              hMenu = GetMenu(frmHaupt.hwnd)
              RetVal = GetMenuString(hMenu, LoWord(wParam), _
               MenuName, Len(MenuName), MF_BYCOMMAND)
              frmHaupt.staStatus.SimpleText = _
               "Es wurde " & NullTrim(MenuName) & " gewhlt"
              ' Debug.Print Hex(LoWord((wParam)))
         End Select
         FensterProz = CallWindowProc(stdWinProc, hwnd, _
          uMsg, wParam, ByVal lParam)
End Function

Function LoWord(dWert As Long) As Integer
    If (dWert And &H8000&) = 0 Then
        LoWord = dWert And &HFFFF&
    Else
        LoWord = &H8000 Or (dWert And &H7FFF&)
    End If
End Function

Function NullTrim(StringWert As String)
    NullTrim = Left(StringWert, InStr(StringWert, Chr(0)) - 1)
End Function




