VERSION 5.00
Begin VB.Form frmHaupt 
   Caption         =   "Kapitel 15: Tricks mit dem Textfeld"
   ClientHeight    =   5490
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6780
   LinkTopic       =   "Form1"
   ScaleHeight     =   5490
   ScaleWidth      =   6780
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Frame Frame1 
      Caption         =   "Aktionsschaltpult"
      Height          =   3015
      Left            =   480
      TabIndex        =   1
      Top             =   2280
      Width           =   5775
      Begin VB.Frame Frame2 
         Height          =   735
         Left            =   2040
         TabIndex        =   11
         Top             =   2160
         Width           =   3495
         Begin VB.CommandButton cmdNormal 
            Caption         =   "Normal"
            Height          =   375
            Left            =   1800
            TabIndex        =   13
            Top             =   240
            Width           =   1575
         End
         Begin VB.CommandButton cmdSchnell 
            Caption         =   "Schnell blinken"
            Height          =   375
            Left            =   120
            TabIndex        =   12
            Top             =   240
            Width           =   1575
         End
      End
      Begin VB.CommandButton cmdUndo 
         Caption         =   "&Undo"
         Height          =   495
         Left            =   3960
         TabIndex        =   10
         Top             =   1560
         Width           =   1575
      End
      Begin VB.CommandButton cmdTabstops 
         Caption         =   "&Tabstops setzen"
         Height          =   495
         Left            =   2040
         TabIndex        =   9
         Top             =   1560
         Width           =   1695
      End
      Begin VB.CommandButton cmdErsteZeileSichtbar 
         Caption         =   "Erste &sichtbare Zeile"
         Height          =   495
         Left            =   240
         TabIndex        =   8
         Top             =   1560
         Width           =   1575
      End
      Begin VB.CommandButton cmdSelektionLschen 
         Caption         =   "Selektiereten Text &lschen"
         Height          =   495
         Left            =   3960
         TabIndex        =   7
         Top             =   960
         Width           =   1575
      End
      Begin VB.CommandButton cmdGendertWeg 
         Caption         =   "Gendert &weg"
         Height          =   495
         Left            =   2040
         TabIndex        =   6
         Top             =   960
         Width           =   1695
      End
      Begin VB.CommandButton cmdGendert 
         Caption         =   "&Gendert?"
         Height          =   495
         Left            =   240
         TabIndex        =   5
         Top             =   960
         Width           =   1575
      End
      Begin VB.CommandButton cmdZeilenbeginn 
         Caption         =   "&Zeichen Nr. am Zeilenbeginn"
         Height          =   495
         Left            =   3960
         TabIndex        =   4
         Top             =   360
         Width           =   1575
      End
      Begin VB.CommandButton cmdAktuelleZeile 
         Caption         =   "&Nr. der aktuellen Zeile"
         Height          =   495
         Left            =   2040
         TabIndex        =   3
         Top             =   360
         Width           =   1695
      End
      Begin VB.CommandButton cmdAnzahlZeilen 
         Caption         =   "&Anzahl Zeilen"
         Height          =   495
         Left            =   240
         TabIndex        =   2
         Top             =   360
         Width           =   1575
      End
   End
   Begin VB.TextBox txtEingabe 
      Height          =   1815
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertikal
      TabIndex        =   0
      Text            =   "frmTextfeldtricks.frx":0000
      Top             =   240
      Width           =   6495
   End
End
Attribute VB_Name = "frmHaupt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function GetCaretBlinkTime Lib "user32" () As Long
Private Declare Function SetCaretBlinkTime Lib "user32" (ByVal wMSeconds As Long) As Long

Const WM_USER = &H400
Const EM_GETLINECOUNT = &HBA
Const EM_LINEFROMCHAR = &HC9
Const EM_LINEINDEX = &HBB
Const EM_GETMODIFY = &HB8
Const EM_SETMODIFY = &HB9
Const WM_CLEAR = &H303
Const EM_GETFIRSTVISIBLELINE = &HCE
Const EM_SETTABSTOPS = &HCB
Const EM_UNDO = &HC7
Private BlinkRate As Long

Private Sub cmdAktuelleZeile_Click()
     Dim Zeilennummer As Integer
     Zeilennummer = SendMessage(txtEingabe.hWnd, EM_LINEFROMCHAR, -1, 0&)
     MsgBox "Zeilennummer: " & Zeilennummer + 1
End Sub

Private Sub cmdAnzahlZeilen_Click()
    Dim AnzahlZeilen As Integer
    AnzahlZeilen = SendMessage(txtEingabe.hWnd, EM_GETLINECOUNT, 0, 0&)
    MsgBox "Anzahl Zeilen: " & AnzahlZeilen
End Sub

Private Sub cmdErsteZeileSichtbar_Click()
     Dim Zeilennummer As Integer
     Zeilennummer = SendMessage(txtEingabe.hWnd, EM_GETFIRSTVISIBLELINE, -1, 0&)
     MsgBox "Erste sichtbare Zeile: " & Zeilennummer + 1
End Sub

Private Sub cmdGendert_Click()
    Dim GendertFlag As Boolean
    GendertFlag = SendMessage(txtEingabe.hWnd, EM_GETMODIFY, 0, 0&) * -1
    MsgBox "Gendert: " & GendertFlag
End Sub

Private Sub cmdGendertWeg_Click()
    Dim RetVal As Long
    RetVal = SendMessage(txtEingabe.hWnd, EM_SETMODIFY, 0, 0&)
    MsgBox "Gendert aufgehoben!"
End Sub

Private Sub cmdSchnell_Click()
    Dim RetVal As Long
    BlinkRate = GetCaretBlinkTime()
    RetVal = SetCaretBlinkTime(BlinkRate \ 2)
End Sub

Private Sub cmdSelektionLschen_Click()
    Dim RetVal As Long
    RetVal = SendMessage(txtEingabe.hWnd, WM_CLEAR, 0, 0&)
End Sub

Private Sub cmdTabstops_Click()
    Dim RetVal As Long
    Dim TabFeld(3) As Long
    TabFeld(0) = 64
    TabFeld(1) = 96
    TabFeld(2) = 128
    RetVal = SendMessage(txtEingabe.hWnd, EM_SETTABSTOPS, 3, TabFeld(0))
    txtEingabe.Refresh
End Sub

Private Sub cmdUndo_Click()
    Dim RetVal As Long
    RetVal = SendMessage(txtEingabe.hWnd, EM_UNDO, 0, 0&)
End Sub

Private Sub cmdZeilenbeginn_Click()
    Dim Zeilenposition As Integer
    Dim Zeilennummer As Integer
    Zeilennummer = SendMessage(txtEingabe.hWnd, EM_LINEFROMCHAR, -1, 0&)
    Zeilenposition = SendMessage(txtEingabe.hWnd, EM_LINEINDEX, Zeilennummer, 0&)
    MsgBox "Zeilenposition: " & Zeilenposition
End Sub

Private Sub cmdNormal_Click()
    Dim RetVal As Long
    RetVal = SetCaretBlinkTime(BlinkRate)
End Sub

Private Sub Form_Load()
    Dim Temp As String
    Temp = "Niederlassungen" & vbTab & "London" & vbTab & "Paris" & vbTab & "Tokio" & vbCrLf
    Temp = Temp & "1. Quartal" & vbTab & "1000" & vbTab & "2000" & vbTab & "3000" & vbCrLf
    Temp = Temp & "2. Quartal" & vbTab & "4000" & vbTab & "5000" & vbTab & "6000" & vbCrLf
    Temp = Temp & "3. Quartal" & vbTab & "7000" & vbTab & "8000" & vbTab & "9000" & vbCrLf
    Temp = Temp & "4. Quartal" & vbTab & "10000" & vbTab & "11000" & vbTab & "12000" & vbCrLf
    txtEingabe.Text = Temp
End Sub
