VERSION 5.00
Begin VB.Form frmHaupt 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Kapitel 16: Prozess beenden mit Toolhelp"
   ClientHeight    =   3630
   ClientLeft      =   1125
   ClientTop       =   870
   ClientWidth     =   6435
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3630
   ScaleWidth      =   6435
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdStart 
      Caption         =   "&Auflisten"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   735
      Left            =   1920
      TabIndex        =   1
      Top             =   2280
      Width           =   2655
   End
   Begin VB.ListBox lstProzesse 
      ForeColor       =   &H00FF0000&
      Height          =   1425
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   5895
   End
   Begin VB.Label Label4 
      Alignment       =   2  'Zentriert
      Caption         =   "Doppelklick auf einen Eintrag beendet den Prozess."
      Height          =   255
      Left            =   240
      TabIndex        =   6
      Top             =   3240
      Width           =   6015
   End
   Begin VB.Label lblAnzahl 
      Height          =   255
      Left            =   1920
      TabIndex        =   5
      Top             =   1920
      Width           =   2655
   End
   Begin VB.Label Label3 
      Caption         =   "Name:"
      Height          =   255
      Left            =   2400
      TabIndex        =   4
      Top             =   120
      Width           =   1935
   End
   Begin VB.Label Label2 
      Caption         =   "Prioritt"
      Height          =   255
      Left            =   1440
      TabIndex        =   3
      Top             =   120
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "Prozess-ID"
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   120
      Width           =   975
   End
End
Attribute VB_Name = "frmHaupt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function CreateToolhelp32Snapshot Lib "Kernel32" (ByVal dwFlags As Long, ByVal dwth32ProcessID As Long) As Long
Private Declare Function Process32First Lib "Kernel32" (ByVal hSnapShot As Long, ByRef lppe As PROCESSENTRY32) As Long
Private Declare Function Process32Next Lib "Kernel32" (ByVal hSnapShot As Long, ByRef lppe As PROCESSENTRY32) As Long
Private Declare Function CloseHandle Lib "Kernel32" (ByVal hObject As Long) As Long
Private Declare Function TerminateProcess Lib "Kernel32" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long
Private Declare Function OpenProcess Lib "Kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long

Const TH32CS_SNAPPROCESS As Long = 2
Const PROCESS_TERMINATE As Long = 1

Private Type PROCESSENTRY32
     dwSize As Long
     cntUsage As Long
     th32ProcessID As Long
     th32DefaultHeapID As Long
     th32ModuleID As Long
     cntThreads As Long
     th32ParentProcessID As Long
     pcPriClassBase As Long
     dwFlags As Long
     szExeFIle As String * 259
End Type

Private Sub cmdStart_Click()
    Dim RetVal As Long
    Dim hSnap As Long
    Dim tmpString As String
    Dim Process32 As PROCESSENTRY32
    Dim Anzahl As Long
    hSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0)
    If hSnap = -1 Then
       MsgBox "Fehler beim Aufruf von CreateToolhelp32SnapShot!", vbExclamation
       Exit Sub
    End If
    Process32.dwSize = LenB(Process32)
    RetVal = Process32First(hSnap, Process32)
    If RetVal <> 1 Then
       MsgBox "Fehler beim Aufruf von Process32First!", vbExclamation
       Exit Sub
    End If
    lstProzesse.Clear
    Do While RetVal = 1
      tmpString = Hex(Process32.th32ProcessID) & vbTab & _
        Process32.pcPriClassBase & vbTab & Process32.szExeFIle
      lstProzesse.AddItem tmpString
      lstProzesse.ItemData(Anzahl) = Process32.th32ProcessID
      Anzahl = Anzahl + 1
      RetVal = Process32Next(hSnap, Process32)
    Loop
    RetVal = CloseHandle(hSnap)
    lblAnzahl.Caption = Anzahl & " Prozesse"
End Sub

Private Sub lstProzesse_DblClick()
    Dim tmpProzessName As String
    Dim ProzessId As Long, hProzess As Long, RetVal As Long
    Dim n As Long, m As Long
    tmpProzessName = lstProzesse.List(lstProzesse.ListIndex)
    Do
      m = n
      n = InStr(n + 1, tmpProzessName, Chr(9))
    Loop Until n = 0
    tmpProzessName = Right(tmpProzessName, Len(tmpProzessName) - m)
    If MsgBox(tmpProzessName & " lschen?", vbQuestion & vbYesNo, "Wichtige Frage") <> vbYes Then Exit Sub
    ProzessId = lstProzesse.ItemData(lstProzesse.ListIndex)
    hProzess = OpenProcess(PROCESS_TERMINATE, 1, ProzessId)
    RetVal = TerminateProcess(hProzess, 0)
    If RetVal = 0 Then
       MsgBox "Fehler beim Terminieren!", vbCritical, "Wichtiger Hinweis"
    End If
    cmdStart_Click
End Sub
