VERSION 5.00
Begin VB.Form frmEditor 
   Caption         =   "Neue Datei"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   Begin VB.TextBox txtEingabe 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1815
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Beides
      TabIndex        =   0
      Top             =   0
      Width           =   4215
   End
End
Attribute VB_Name = "frmEditor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Const EM_GETLINECOUNT = &HBA
Private Const EM_LINEFROMCHAR = &HC9
Private Const EM_LINEINDEX = &HBB
Private Const EM_CANUNDO = &HC6
Private Const EM_UNDO = &HC7

Private mDirtyFlag As Boolean
Private mDateiname As String

Private Sub Form_Activate()
    PositionAusgeben
End Sub

Private Sub Form_Load()
    txtEingabe.Left = 0
    txtEingabe.Top = 0
    mdiHaupt.staStatus.Visible = True
    If bOptionExlicitEinfgen = True Then
       txtEingabe.Text = txtEingabe.Text + "Option Explicit" + vbCrLf
       txtEingabe.SelStart = Len(txtEingabe.Text)
    End If
    If bOptionShellObjektAnlegen = True Then
       txtEingabe.Text = txtEingabe.Text + "Dim WshShell" + vbCrLf
       txtEingabe.Text = txtEingabe.Text + "Set WshShell = WScript.CreateObject(" & Chr(34) & "WScript.Shell" & Chr(34) & ")" + vbCrLf
       txtEingabe.SelStart = Len(txtEingabe.Text)
    End If
    If bNetworkObjektAnlegen = True Then
       txtEingabe.Text = txtEingabe.Text + "Dim WshNetwork" + vbCrLf
       txtEingabe.Text = txtEingabe.Text + "Set WshShell = WScript.CreateObject(" & Chr(34) & "WScript.Network" & Chr(34) & ")" + vbCrLf
       txtEingabe.SelStart = Len(txtEingabe.Text)
    End If
    
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Dim Antwort As Integer
    If DirtyFlag = True Then
       Antwort = MsgBox(Prompt:="Modul vor dem Verlassen speichern?", Buttons:=vbQuestion + vbYesNoCancel, Title:="Skript ist noch nicht gesichert")
       If Antwort = vbYes Then
          ModulSpeichern
       ElseIf Antwort = vbCancel Then
          Cancel = True
       End If
    End If
End Sub

Private Sub Form_Resize()
    txtEingabe.Width = Me.ScaleWidth
    txtEingabe.Height = Me.ScaleHeight
End Sub

Sub PositionAusgeben()
    Dim Zeile As Long, Spalte As Long, GesamtZeilen As Long
    Spalte = SendMessage(txtEingabe.hwnd, EM_LINEINDEX, -1, 0)
    Zeile = SendMessage(txtEingabe.hwnd, EM_LINEFROMCHAR, Spalte, 0) + 1
    Spalte = Abs(txtEingabe.SelStart - Spalte) + 1
    GesamtZeilen = SendMessage(txtEingabe.hwnd, EM_GETLINECOUNT, 0, 0)
    mdiHaupt.staStatus.Panels("Zeile").Text = "Zeile: " & Zeile
    mdiHaupt.staStatus.Panels("Spalte").Text = "Spalte: " & Spalte
    mdiHaupt.staStatus.Panels("Gesamtzeilen").Text = "Gesamt: " & GesamtZeilen
End Sub

Private Sub Form_Unload(Cancel As Integer)
    If Forms.Count = 2 Then
       mdiHaupt.staStatus.Visible = False
    End If
End Sub

Private Sub txtEingabe_Click()
    PositionAusgeben
End Sub

Private Sub txtEingabe_KeyPress(KeyAscii As Integer)
    Me.DirtyFlag = True
End Sub

Private Sub txtEingabe_KeyUp(KeyCode As Integer, Shift As Integer)
    PositionAusgeben
End Sub

Property Let DirtyFlag(tmpWert As Boolean)
    mDirtyFlag = tmpWert
End Property

Property Get DirtyFlag() As Boolean
    DirtyFlag = mDirtyFlag
End Property

Property Let Dateiname(tmpWert As String)
    mDateiname = tmpWert
End Property

Property Get Dateiname() As String
    Dateiname = mDateiname
End Property
