VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "AboutBox Sample"
   ClientHeight    =   2265
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4275
   LinkTopic       =   "Form1"
   ScaleHeight     =   2265
   ScaleWidth      =   4275
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command1 
      Caption         =   "New Form"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   405
      TabIndex        =   0
      Top             =   450
      Width           =   3030
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_wndprcNext As Long
Private Const IDM_ABOUT As Long = 1000
#If DEBUGWINDOWPROC Then
Private m_SCHook As WindowProcHook
#End If

Private Sub SubClass()
    UnSubClass
#If USEGETPROP Then
    Debug.Assert GetProp(hWnd, Atomizer) = 0
    SetProp hWnd, Atomizer, ObjPtr(Me)
#Else
    Debug.Assert GetWindowLong(hWnd, GWL_USERDATA) = 0
    SetWindowLong hWnd, GWL_USERDATA, ObjPtr(Me)
#End If
#If DEBUGWINDOWPROC Then
    On Error Resume Next
    Set m_SCHook = CreateWindowProcHook
    If Err Then
        MsgBox Err.Description
        Err.Clear
        UnSubClass
        Exit Sub
    End If
    On Error GoTo 0
    With m_SCHook
        .SetMainProc AddressOf Form1Proc
        m_wndprcNext = SetWindowLong(hWnd, GWL_WNDPROC, .ProcAddress)
        .SetDebugProc m_wndprcNext
    End With
#Else
    m_wndprcNext = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf Form1Proc)
#End If
End Sub

Private Sub UnSubClass()
    If m_wndprcNext Then
        SetWindowLong hWnd, GWL_WNDPROC, m_wndprcNext
        #If USEGETPROP Then
            RemoveProp hWnd, Atomizer
        #Else
            SetWindowLong hWnd, GWL_USERDATA, 0&
        #End If
        m_wndprcNext = 0
    End If
End Sub
Friend Function WindowProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim hSysMenu As Long
    Select Case uMsg
        Case WM_INITMENUPOPUP
            If lParam \ 65535 And &HFFFF& Then 'HIWORD of lparam
                hSysMenu = GetSystemMenu(hWnd, 0)
                If wParam = hSysMenu Then
                    EnableMenuItem hSysMenu, IDM_ABOUT, ByVal IIf(WindowState = vbMinimized, MF_GRAYED, 0)
                End If
            End If
        Case WM_SYSCOMMAND
            Select Case wParam
                Case IDM_ABOUT
                    MsgBox "About box"
            End Select
    End Select
    WindowProc = CallWindowProc(m_wndprcNext, hWnd, uMsg, wParam, ByVal lParam)
End Function

Private Sub Command1_Click()
    Dim frm1 As New Form1
    frm1.Show
End Sub

Private Sub Form_Load()
    AppendMenu GetSystemMenu(hWnd, 0), MF_SEPARATOR, 0&, 0&
    AppendMenu GetSystemMenu(hWnd, 0), MF_STRING, IDM_ABOUT, "&About..."
    SubClass
End Sub

Private Sub Form_Unload(Cancel As Integer)
    UnSubClass
End Sub
