VERSION 5.00
Begin VB.Form frmHaupt 
   Caption         =   "Kapitel 16: Mini-Texteditor mit Bearbeiten-Men"
   ClientHeight    =   5460
   ClientLeft      =   60
   ClientTop       =   630
   ClientWidth     =   8910
   LinkTopic       =   "Form1"
   ScaleHeight     =   5460
   ScaleWidth      =   8910
   StartUpPosition =   3  'Windows-Standard
   Begin VB.TextBox txtTextfeld 
      BackColor       =   &H00FFFF80&
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   4215
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertikal
      TabIndex        =   0
      Text            =   "frmMiniEditor.frx":0000
      Top             =   360
      Width           =   8175
   End
   Begin VB.Menu mnuBearbeiten 
      Caption         =   "&Bearbeiten"
      Begin VB.Menu mnuAusschneiden 
         Caption         =   "&Ausschneiden"
         Shortcut        =   ^X
      End
      Begin VB.Menu mnuKopieren 
         Caption         =   "&Kopieren"
         Shortcut        =   ^C
      End
      Begin VB.Menu mnuEinfgen 
         Caption         =   "&Einfgen"
         Shortcut        =   ^V
      End
      Begin VB.Menu mnuLschen 
         Caption         =   "&Lschen"
      End
      Begin VB.Menu mnuStrich1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuAllesMarkieren 
         Caption         =   "&Alles markieren"
         Shortcut        =   ^A
      End
   End
   Begin VB.Menu mnuZwischenablageLeeren 
      Caption         =   "Zwischenablage leeren"
   End
End
Attribute VB_Name = "frmHaupt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub mnuAllesMarkieren_Click()
    txtTextfeld.SelStart = 0
    txtTextfeld.SelLength = Len(txtTextfeld.Text)
End Sub

Private Sub mnuAusschneiden_Click()
    Dim Temp As String, TextMarkePosition As Integer
    Clipboard.SetText txtTextfeld.SelText, vbCFText
    TextMarkePosition = txtTextfeld.SelStart
    Temp = Left(txtTextfeld.Text, TextMarkePosition)
    Temp = Temp & Right(txtTextfeld.Text, _
     Len(txtTextfeld.Text) - (txtTextfeld.SelStart + _
     txtTextfeld.SelLength))
    txtTextfeld.Text = Temp
    txtTextfeld.SelStart = TextMarkePosition
End Sub

Private Sub mnuBearbeiten_Click()
'Zunchst einmal alle Befehle deaktivieren
    mnuEinfgen.Enabled = False
    mnuAusschneiden.Enabled = False
    mnuKopieren.Enabled = False
    mnuLschen.Enabled = False
    If Clipboard.GetFormat(vbCFText) = True Then
       mnuEinfgen.Enabled = True
       mnuZwischenablageLeeren.Enabled = True
    Else
       mnuZwischenablageLeeren.Enabled = False
    End If

' Ist Text in der Zwischenablage enthalten
    If Clipboard.GetFormat(vbCFText) = True And TypeOf _
     Screen.ActiveControl Is TextBox Then
        mnuEinfgen.Enabled = True
        mnuZwischenablageLeeren.Enabled = True
    End If
' Wurde Text markiert?
    If txtTextfeld.SelText <> "" Then
        mnuKopieren.Enabled = True
        mnuAusschneiden.Enabled = True
        mnuLschen.Enabled = True
    End If
End Sub

Private Sub mnuEinfgen_Click()
    txtTextfeld.SelText = Clipboard.GetText(vbCFText)
End Sub

Private Sub mnuKopieren_Click()
    Clipboard.SetText txtTextfeld.SelText, vbCFText
End Sub

Private Sub mnuLschen_Click()
    Dim Temp As String, TextMarkePosition As Integer
    TextMarkePosition = txtTextfeld.SelStart
    Temp = Left(txtTextfeld.Text, TextMarkePosition)
    Temp = Temp & Right(txtTextfeld.Text, _
     Len(txtTextfeld.Text) - (txtTextfeld.SelStart + _
     txtTextfeld.SelLength))
    txtTextfeld.Text = Temp
    txtTextfeld.SelStart = TextMarkePosition
End Sub

Private Sub mnuZwischenablageLeeren_Click()
    Clipboard.Clear
End Sub
