VERSION 5.00
Object = "{00028C01-0000-0000-0000-000000000046}#1.0#0"; "DBGRID32.OCX"
Begin VB.Form frmHaupt 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Kapitel 18: SQL-Trainer"
   ClientHeight    =   4530
   ClientLeft      =   2340
   ClientTop       =   2100
   ClientWidth     =   9060
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'ZReihenfolge
   ScaleHeight     =   4530
   ScaleWidth      =   9060
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdListeLschen 
      Caption         =   "&Liste lschen"
      Height          =   375
      Left            =   7920
      TabIndex        =   8
      Top             =   1080
      Width           =   1095
   End
   Begin VB.ComboBox cboSQLStatements 
      BackColor       =   &H00008000&
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0000FFFF&
      Height          =   390
      Left            =   0
      Style           =   2  'Dropdown-Liste
      TabIndex        =   7
      Top             =   1080
      Width           =   7815
   End
   Begin VB.CommandButton cmdZwischenablage 
      Caption         =   "&Tabelle in Zwischenablage"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   615
      Left            =   5760
      TabIndex        =   6
      Top             =   1800
      Width           =   3255
   End
   Begin VB.Frame Frame1 
      Caption         =   "&Basistabellen"
      Height          =   975
      Left            =   0
      TabIndex        =   3
      Top             =   1680
      Width           =   2295
      Begin VB.OptionButton optAuftrge 
         Caption         =   "&Auftrge"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   600
         Width           =   1335
      End
      Begin VB.OptionButton optProminente 
         Caption         =   "&Prominente"
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   240
         Width           =   1335
      End
   End
   Begin VB.CommandButton cmdSQLAusfhren 
      Caption         =   "&SQL-Statement ausfhren"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   615
      Left            =   2400
      TabIndex        =   2
      Top             =   1800
      Width           =   3255
   End
   Begin VB.TextBox txtSQLStatement 
      BackColor       =   &H00008000&
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0000FFFF&
      Height          =   975
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   1
      Top             =   0
      Width           =   9015
   End
   Begin VB.Data datProminenten 
      Caption         =   "Data1"
      Connect         =   "Access"
      DatabaseName    =   ""
      DefaultCursorType=   0  'Standard-Cursor
      DefaultType     =   2  'ODBC verwenden
      Exclusive       =   0   'False
      Height          =   300
      Left            =   2760
      Options         =   0
      ReadOnly        =   0   'False
      RecordsetType   =   1  'Dynaset
      RecordSource    =   ""
      Top             =   4200
      Width           =   3975
   End
   Begin MSDBGrid.DBGrid DBGrid1 
      Bindings        =   "frmSQLTrainer.frx":0000
      Height          =   1335
      Left            =   0
      OleObjectBlob   =   "frmSQLTrainer.frx":0019
      TabIndex        =   0
      Top             =   2760
      Width           =   9015
   End
End
Attribute VB_Name = "frmHaupt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *******************************
' Beispielprogramm 22.2
' Datenbankzugriff mit SQL
' Das Visual Basic 4 Kompendium
' Peter Monadjemi, Markt&Technik 1996
' *******************************
Option Explicit

' Der Allgemein-Teil
Dim SQLAuswahl As Boolean

' Die Ereignisprozedur cboSQLStatements_Click
Private Sub cboSQLStatements_Click()
    ' Wenn Liste leer, dann kann nichts bertragen werden
    If cboSQLStatements.ListCount = 0 Then Exit Sub
    ' Ausgewhltes SQL-Statement in das Textfeld
    txtSQLStatement.Text = cboSQLStatements.Text
    ' Erneuten Vergleich des SQL-Statements vor der Ausfhrung verhindern
    SQLAuswahl = True
End Sub

' Die Ereignisprozedur cmdListeLschen_Click
Private Sub cmdListeLschen_Click()
' Lscht die Liste mit den gespeicherten SQL-Statements
    cboSQLStatements.Clear
End Sub

' Die Ereignisprozedur cmdSQLAusfhren_Click
Private Sub cmdSQLAusfhren_Click()
' Laufzeitfehler mssen unbedingt abgefangen werden, da SQL-Statement Fehler enthalten kann
    On Error GoTo cmdSQLAusfhren_Error
    Dim SQLStatement As String
    Dim Gefunden As Boolean, n As Integer
' Eingegebenes SQL-Statement bernehmen
    SQLStatement = txtSQLStatement.Text
' Wurde berhaupt etwas eingegeben?
    If SQLStatement = "" Then
       MsgBox "Bitte SQL-Statement eingeben!", vbExclamation, "Wichtiger Hinweis"
       txtSQLStatement.SetFocus
       Exit Sub
    End If
' Mu die SQL-Statementliste durchsucht werden?
    If SQLAuswahl = True Then
' Ist das SQL-Statements bereits in der Liste enthalten
        For n = 0 To cboSQLStatements.ListCount - 1
            If SQLStatement = cboSQLStatements.List(n) Then
               Gefunden = True
               Exit For
            End If
        Next n
    End If
' Wenn nichts gefunden wurde, dann SQL-Statement in Liste bernehmen
    If Gefunden = False Then cboSQLStatements.AddItem SQLStatement
' Ist es eine UPDATE-Aktionsabfrage?
    If Left(LTrim(SQLStatement), 6) = "UPDATE" Then
       datProminenten.Database.Execute SQLStatement
    Else
' Nein, dann eine normale SQL-Abfrage
       datProminenten.RecordSource = SQLStatement
    End If
' Datensatzgruppe neu aufbauen
    datProminenten.Refresh
    Exit Sub
cmdSQLAusfhren_Error:
    Select Case Err.Number
    Case 3061, 3141   ' Fehler im SQL-Statement
        MsgBox "Fehler im SQL-Statement!", vbExclamation, "Wichtiger Hinweis"
        txtSQLStatement.SelStart = 1
        txtSQLStatement.SelLength = Len(txtSQLStatement.Text)
        txtSQLStatement.SetFocus
        Exit Sub
    Case Else
' "Unbekannter"-Fehler werden anzeigt und dann ignoriert - fr die bung die beste Lsung
        MsgBox Err.Description & " (" & Err.Number & ")", vbExclamation, "Laufzeitfehler"
    End Select
End Sub

' Die Ereignisprozedur cmdZwischenablage_Click
Private Sub cmdZwischenablage_Click()
' Aktuellen Inhalt des Recordset-Objekts in die Zwischenablage bertragen
    Dim X As Field
    Dim Buchmarke As String, Temp As String
' Aktuellen Stand des Datensatzzeigers bitte merken
    Buchmarke = datProminenten.Recordset.Bookmark
' Als erstes die Namen der Felder bertragen
    For Each X In datProminenten.Recordset.Fields
' String aus allen Feldnamen zusammenbasteln
        Temp = Temp & Chr(9) & X.Name
    Next X
' Auf den ersten Datensatz springen
    datProminenten.Recordset.MoveFirst
' Alle Datenstze der Reihe nach durchgehen
    Do While Not datProminenten.Recordset.EOF
' Alle Felder des aktuellen Datensatzes durchgehen
        For Each X In datProminenten.Recordset.Fields
' String aus allen Feldwerten zusammenbasteln
            Temp = Temp & Chr(9) & X.Value
        Next X
' Zeilenumbruch an jede Zeilen hngen
        Temp = Temp & vbCrLf

' Auf zum nchsten Datensatz
        datProminenten.Recordset.MoveNext
    Loop
' Alte Position des Datensatzzeigers wiederherstellen
    datProminenten.Recordset.Bookmark = Buchmarke
' Tabellenstring in die Zwischenablage
    Clipboard.SetText Temp, vbCFText
End Sub

' Die Ereignisprozedur Form_Load
Private Sub Form_Load()
    Dim Dateiname As String
    Dim DateiNr As Integer, n As Integer, Temp As String
    On Error GoTo FormLoad_Error
' Wichtig: Pfad der Datenbank mu gegebenenfalls angepat werden
    datProminenten.DatabaseName = App.Path & "\Promis.mdb"
' berschrift des Datensteuerelements setzen
    datProminenten.Caption = datProminenten.RecordSource
    optProminente.Value = True
' Wichtig: Der Pfad der Datei Promi.dat mu gegebenenfalls angepat werden
    Dateiname = "Promi.dat"
' Bereits gespeicherte SQL-Statements aus der Datei Promi.dat einlesen
    DateiNr = FreeFile
    Open Dateiname For Input As DateiNr
    Do While Not EOF(DateiNr)
       Input #DateiNr, Temp
       cboSQLStatements.AddItem Temp
    Loop
    Close DateiNr
' Zuletzt eingegebenes SQL-Statement in Textfeld bertragen und auswhlen
    txtSQLStatement.Text = cboSQLStatements.Text
    If cboSQLStatements.ListIndex >= 0 Then cboSQLStatements.ListIndex = 0
    Exit Sub
FormLoad_Error:
    Select Case Err.Number
    Case 53 ' File not found
        Exit Sub
    Case Else
        MsgBox Err.Description & " (" & Err.Number & ")", vbExclamation, "Laufzeitfehler"
        Stop
    End Select
End Sub

' Die Ereignisprozedur Form_Unload
Private Sub Form_Unload(Cancel As Integer)
' Beim Entladen der Form alle SQL-Strings speichern
    Dim DateiNr As Integer
    Dim n As Integer, Temp As String
    DateiNr = FreeFile
' Alle Listenelemente in die Datei Promi.dat bertragen
    Open "Promi.dat" For Output As DateiNr
        For n = 0 To cboSQLStatements.ListCount - 1
            Temp = cboSQLStatements.List(n)
            Write #DateiNr, Temp
        Next n
    Close DateiNr
End Sub

' Die Ereignisprozedur optAuftrge_Click
Private Sub optAuftrge_Click()
' Auswahl der Tabelle Auftrge
    datProminenten.RecordSource = "Auftrge"
    datProminenten.Refresh
    datProminenten.Caption = datProminenten.RecordSource
End Sub

' Die Ereignisprozedur optProminente_Click
Private Sub optProminente_Click()
' Auswahl der Tabelle Prominente
    datProminenten.RecordSource = "Prominente"
    datProminenten.Refresh
    datProminenten.Caption = datProminenten.RecordSource
End Sub

' Die Ereignisprozedur txtSQLStatement_Change
Private Sub txtSQLStatement_Change()
' SQL-Statement wurde gendert
    SQLAuswahl = False
End Sub
