VERSION 5.00
Begin VB.UserControl usrFlagge 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   PropertyPages   =   "usrFlagge.ctx":0000
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.Image imgNothing 
      Height          =   480
      Left            =   3720
      Top             =   2520
      Visible         =   0   'False
      Width           =   480
   End
   Begin VB.Image imgAnzeige 
      BorderStyle     =   1  'Fest Einfach
      Height          =   2175
      Left            =   480
      Top             =   480
      Width           =   2775
   End
End
Attribute VB_Name = "usrFlagge"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private mLand As Integer
Private mStretchModus As Boolean
Private mPfadname As String
Private Const mDefaultPfad = "C:\Programme\Microsoft Visual Studio\Common\Graphics\Icons\Flags\"

Enum LnderEnums
    KeinLand
    Australien
    sterreich
    Belgien
    Brasilien
    Kanada
    Dnemark
    Finnland
    Frankreich
    Deutschland
    Irland
    Italien
    Japan
    Mexiko
    Niederlande
    Norwegen
    Neuseeland
    Portugal
    Sdafrika
    Ruland
    Spanien
    Schweden
    Schweiz
    Trkei
    Grobritannien
    USA
End Enum
    
Public Property Let Picture(PictureObject As Variant)
    imgAnzeige.Picture = PictureObject
End Property

Public Property Let Land(LandName As LnderEnums)
    mLand = LandName
    If LnderListe(mLand).Pfadname = "Nothing" Then
       Picture = imgNothing.Picture
    Else
       Picture = LoadPicture(LnderListe(mLand).Pfadname)
    End If
End Property

Public Property Get Land() As LnderEnums
    Land = mLand
End Property

Private Sub UserControl_Initialize()
    imgAnzeige.Top = 0
    imgAnzeige.Left = 0
    imgAnzeige.Width = UserControl.ScaleWidth
    imgAnzeige.Height = UserControl.ScaleHeight
    IcoPfadname = mDefaultPfad
    LnderListeLaden Me
End Sub

Private Sub UserControl_Resize()
    imgAnzeige.Width = UserControl.ScaleWidth
    imgAnzeige.Height = UserControl.ScaleHeight
End Sub

Public Property Get BorderStyle() As BorderStyleConstants
Attribute BorderStyle.VB_Description = "Gibt den Rahmenstil fr ein Objekt zurck oder legt diesen fest."
    BorderStyle = imgAnzeige.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As BorderStyleConstants)
    imgAnzeige.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    imgAnzeige.BorderStyle = PropBag.ReadProperty("BorderStyle", 1)
    imgAnzeige.Stretch = PropBag.ReadProperty("Stretch", False)
    Me.IcoPfadname = PropBag.ReadProperty("IcoPfadname", mDefaultPfad)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("BorderStyle", imgAnzeige.BorderStyle, 1)
    Call PropBag.WriteProperty("Stretch", imgAnzeige.Stretch)
    Call PropBag.WriteProperty("IcoPfadname", Me.IcoPfadname)
End Sub

Property Let Stretch(Modus As Boolean)
    mStretchModus = Modus
    imgAnzeige.Stretch = mStretchModus
    imgAnzeige.Width = UserControl.ScaleWidth
    imgAnzeige.Height = UserControl.ScaleHeight
    PropertyChanged "Stretch"
End Property

Property Get Stretch() As Boolean
    Stretch = mStretchModus
End Property

Property Let IcoPfadname(Pfadname As String)
    mPfadname = Pfadname
    basFlaggenServer.LnderListeLaden Me
End Property

Property Get IcoPfadname() As String
    IcoPfadname = mPfadname
End Property
