VERSION 5.00
Object = "{FE0065C0-1B7B-11CF-9D53-00AA003C9CB6}#1.1#0"; "COMCT232.OCX"
Begin VB.UserControl usrZhleinheit 
   ClientHeight    =   1320
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2655
   ScaleHeight     =   1320
   ScaleWidth      =   2655
   Begin ComCtl2.UpDown updZhler 
      Height          =   615
      Left            =   1816
      TabIndex        =   1
      Top             =   240
      Width           =   240
      _ExtentX        =   423
      _ExtentY        =   1085
      _Version        =   327681
      OrigLeft        =   1816
      OrigTop         =   240
      OrigRight       =   2056
      OrigBottom      =   855
      Max             =   32767
      Wrap            =   -1  'True
      Enabled         =   -1  'True
   End
   Begin VB.TextBox txtEingabe 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   615
      Left            =   480
      TabIndex        =   0
      Top             =   240
      Width           =   1335
   End
   Begin VB.Menu mnuInfo 
      Caption         =   "&Info"
      NegotiatePosition=   1  'Links
   End
End
Attribute VB_Name = "usrZhleinheit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' ************************************************
' Kapitel 20
' Beispiel fr ein gebundenes Benutzersteuerelement
'
' ************************************************

Option Explicit
Private mValue As Long
Private mNoChangeEvent As Boolean
Private mTextInhalt As String
Private mHintergrundfarbe As OLE_COLOR
Private mFont As StdFont

Private mAutoSize As Boolean

' Wichtig: Das ndern der Value-Eigenschaft ndert automatisch
' die DataChanged-Eigenschaft des Benutzersteuerelements

Property Let Value(tmpValue As Long)
   On Error GoTo errValue
   If CanPropertyChange("Value") Then
      mValue = tmpValue
      txtEingabe.Text = mValue
      If mNoChangeEvent = False Then
         updZhler.Value = mValue
      End If
Weiter:
      PropertyChanged ("Value")
  End If
  Exit Property
errValue:
    Select Case Err.Number
    Case 380    ' Eigenschaftswert passt nicht
      updZhler.Value = 32767
      Resume Weiter
    End Select
  End Property

Property Get Value() As Long
Attribute Value.VB_Description = "Aktueller Wert der Zahl im Textfeld."
Attribute Value.VB_ProcData.VB_Invoke_Property = ";Daten"
Attribute Value.VB_UserMemId = 0
Attribute Value.VB_MemberFlags = "234"
    Value = mValue
End Property

Private Sub mnuInfo_Click()
    ShowInfoBox
End Sub

Private Sub txtEingabe_Change()
    If txtEingabe.Text = "" Or IsNumeric(txtEingabe.Text) = False Then
       Value = 0
    Else
       Value = CLng(txtEingabe.Text)
    End If
End Sub

Private Sub txtEingabe_KeyPress(KeyAscii As Integer)
' Ist im Prinzip nicht erforderlich, da bereits das Change-Ereignis
' die Value-Eigenschaft ndert, was zum Setzen von DataChanged fhrt
'    UserControl.Extender.DataChanged = True
End Sub

Private Sub updZhler_Change()
    mNoChangeEvent = True
    Value = updZhler.Value
    mNoChangeEvent = False
End Sub

Property Let AutoSize(tmpWert As Boolean)
Attribute AutoSize.VB_UserMemId = -500
    mAutoSize = tmpWert
End Property

Property Get AutoSize() As Boolean
    AutoSize = mAutoSize
End Property
Private Sub UserControl_Initialize()
    txtEingabe.Text = 0
    txtEingabe.Top = 0
    txtEingabe.Left = 0
    updZhler.Left = txtEingabe.Width + 1
    updZhler.Top = 0
    Set Zeichensatz = txtEingabe.Font
    PropertyChanged "Zeichensatz"
End Sub

Private Sub UserControl_InitProperties()
    UserControl.Width = updZhler.Left + updZhler.Width + 1
    UserControl.Height = txtEingabe.Height
End Sub

Public Property Let Textinhalt(tmpTextwert As String)
    mTextInhalt = tmpTextwert
    txtEingabe.Text = mTextInhalt
End Property

Public Property Get Textinhalt() As String
Attribute Textinhalt.VB_UserMemId = -517
    Textinhalt = mTextInhalt
End Property

Public Property Set Zeichensatz(tmpFont As StdFont)
    Set txtEingabe.Font = tmpFont
    Set mFont = tmpFont
End Property

Public Property Get Zeichensatz() As StdFont
    Set Zeichensatz = mFont
End Property
Public Property Let Hintergrundfarbe(tmpFarbwert As OLE_COLOR)
    mHintergrundfarbe = tmpFarbwert
    UserControl.BackColor = tmpFarbwert
End Property

Public Property Get Hintergrundfarbe() As OLE_COLOR
    Hintergrundfarbe = mHintergrundfarbe
End Property

Sub ShowInfoBox()
Attribute ShowInfoBox.VB_UserMemId = -552
    frmAbout.Show vbModal
    Set frmAbout = Nothing
End Sub

